/*
 * netdb.h 1998/05/01
 * Modified by K.Shirakata
 * Modified by Kazuya 'Sharl' Masuda
 */
#ifndef	__netdb_h__
#define	__netdb_h__

struct hostent {
	char *h_name;
	char **h_aliases;
	int h_addrtype;
	int h_length;
	char **h_addr_list;
};
#define h_addr h_addr_list[0]

struct netent {
	char *n_name;
	char **n_aliases;
	int n_addrtype;
	unsigned long n_net;
};

struct protoent {
	char *p_name;
	char **p_aliases;
	int p_proto;
};

struct servent {
	char *s_name;
	char **s_aliases;
	int s_port;
	char *s_proto;
};

struct hostent *gethostbyname(const char *);
struct hostent *gethostbyaddr(const char *, int, int);
struct netent *getnetbyname(const char *);
struct netent *getnetbyaddr(unsigned long, int);
struct servent *getservbyname(const char *, const char *);
struct servent *getservbyport(int, const char *);
struct servent *getservent(void);
struct protoent *getprotobyname(const char *);
struct protoent *getprotobynumber(int);
struct protoent *getprotoent(void);

int close_s(int);
int read_s(int, char *, int);
int write_s(int, const char *, int);

int res_search (char *, int, int, unsigned char *, int);

#endif
