/*
 * gethostnamadr.c
 *
 * Copyright (C) 1994 First Class Technology.
 * Modified 1996 by K.Shirakata
 * Modified 1998,99 by Kazuya 'Sharl' Masuda
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/nameser.h>
#include <netdb.h>
#include <tcpipdrv.h>
#include "gethostsub.h"

static struct hostent *_gethostbyaddr(unsigned char *, int, int);
static struct hostent *__gethostbyaddr(unsigned char *, int, int);

_ti_func search_ti_entry(void);

struct hostent *
gethostbyaddr(const char *adr, int len, int type)
{
	struct hostent *hp;

	hp = __gethostbyaddr((unsigned char *)adr, len, type);
	if (hp)
		return hp;

	hp = _gethostbyaddr((unsigned char *)adr, len, type);
	return _copyhost(hp);
}

static struct hostent *
_gethostbyaddr(unsigned char *addr, int len, int type)
{
	_ti_func func = search_ti_entry();
	if (func) {
		long argv[3];

		argv[0] = (long)addr;
		argv[1] = (long)len;
		argv[2] = (long)type;

		return (struct hostent *)func(_TI_gethostbyaddr, argv);
	}
	return NULL;
}

static struct hostent *
__gethostbyaddr(unsigned char *addr, int len, int type)
{
	unsigned char answer[2048];
	int anslen;

	if (type != AF_INET || len != sizeof(long))
		 return NULL;

	{
		/* Query to in-addr.arpa */
		unsigned char buff[64];

		sprintf(buff, "%u.%u.%u.%u.in-addr.arpa",
			*(addr + 3), *(addr + 2), *(addr + 1), *addr);

		anslen = res_search(buff, C_IN, T_PTR, answer, sizeof(answer));
		if (anslen > 0)
			return make_hostent(answer, anslen);
	}
	return NULL;
}
