/*
 * gethostbyname.c
 *
 * Copyright (C) 1994 First Class Technology.
 * Modified 1996 by K.Shirakata
 * Modified 1998,99 by Kazuya 'Sharl' Masuda
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/nameser.h>
#include <netdb.h>
#include <tcpipdrv.h>
#include "gethostsub.h"

static struct hostent *_gethostbyname(unsigned char *);
static struct hostent *__gethostbyname(unsigned char *);

_ti_func search_ti_entry(void);

struct hostent *
gethostbyname(const char *name)
{
	struct hostent *hp;

	hp = __gethostbyname((unsigned char *)name);
	if (hp)
		return hp;

	hp = _gethostbyname((unsigned char *)name);
	return _copyhost(hp);
}

static struct hostent *
_gethostbyname(unsigned char *name)
{
	_ti_func func = search_ti_entry();
	if (func)
		return (struct hostent *)func(_TI_gethostbyname, (long *)name);
	return NULL;
}

static struct hostent *
__gethostbyname(unsigned char *name)
{
	unsigned char answer[2048];
	int anslen;

	anslen = res_search(name, C_IN, T_A, answer, sizeof(answer));
	if (anslen > 0)
		return make_hostent(answer, anslen);
	else
		return NULL;
}
