/*
 * sockmode.c
 *
 * Copyright (C) 1994 First Class Technology.
 * Modified by K.Shirakata
 * Modified by Kazuya 'Sharl' Masuda
 */
#include <fcntl.h>
#include <sys/socket.h>
#include <tcpipdrv.h>

_ti_func search_ti_entry(void);

int
sockmode(int a, int b)
{
	_ti_func func = search_ti_entry();

	if (func) {
		long arg[2];
		int r;

		arg[0] = a;
		arg[1] = (long)b;

		r = func(_TI_sockmode, arg);
		if (r == 0) {
			int fm;
			fm = fcntl(a, F_GETFL) & ~(O_TEXT | O_BINARY);
			fm |= (b ? O_TEXT : O_BINARY);
			fcntl(a, F_SETFL, fm);
		}
		return r;
	}
	return -1;
}
